{-----------------------------------------------------------------------------
   Unit Name: mittak
   Purpose  : Malliohjelma mittakaavamuunnoksista.
   Author   : Vesa Lappalainen
   Date     : 17.12.1997
   Changed  : 04.11.2001
    + CLX compiling
   Todo     :

   Opetuksia:
     1) Tapahtuma ilman nappulan painamista.
     2) Enterin ksittely (piilotettu default.nappula)
     3) "Lineaarisia" muunnoksia tekev TUnitComboBox -luokka
     4) TEditDouble -luokassa malli uudelleen mritellyst
        tapahtuman ksittelyst (hook).

   Tehtvi:
     1) Lis TUnits-luokkaan mahdollisuus lukea yksikt tiedostosta
        automaattisesti kynnistyksen yhteydess (property FileName).
     2) Korjaa TUnits niin ett siihen liitytn jseneksi ja
        saadaan tieto TUnitComboBoxille kun TUnits poistuu tai muuttuu
-----------------------------------------------------------------------------}

unit mittak;


interface

uses
  SysUtils, Classes,
{$ifdef CLX}
  QGraphics, QControls, QForms, QDialogs, QMenus, QStdCtrls,
{$else}
  Windows, Messages,
  Graphics, Controls, Forms, Dialogs, Menus, StdCtrls,
{$endif}
  EditDouble, UnitComboBox;

type
  TFormMuunnos = class(TForm)
    EditKartalla: TEditDouble;
    EditMittak: TEditDouble;
    EditLuonnossa: TEditDouble;
    ButtonSelectAll: TButton;
    CBKartallaYks: TUnitComboBox;
    CBLuonnossaYks: TUnitComboBox;
    UnitsMitat: TUnits;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Map1: TMenuItem;
    N1100001: TMenuItem;
    N1200001: TMenuItem;
    GT1: TMenuItem;
    N111: TMenuItem;
    Apua1: TMenuItem;
    Tietoja1: TMenuItem;
    Kieli1: TMenuItem;
    Suomi1: TMenuItem;
    Englanti1: TMenuItem;
    procedure EditKartallaChange(Sender: TObject);
    procedure EditLuonnossaChange(Sender: TObject);
    procedure ButtonSelectAllClick(Sender: TObject);
    procedure CBKartallaYksChange(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure GT1Click(Sender: TObject);
    procedure Tietoja1Click(Sender: TObject);
    procedure Suomi1Click(Sender: TObject);
  private
    procedure LaskeKartalla; virtual;
    procedure LaskeLuonnossa; virtual;
    function  YksKerroin : double;
  public
  end;

var
  FormMuunnos: TFormMuunnos;

implementation

{$ifdef CLX}
{$R *.dfm}
{$else}
{$R *.dfm}
{$endif}

function  TFormMuunnos.YksKerroin : double;
var fk,fl : double;
begin
  Result := 1;
  fk := CBKartallaYks.Factor;
  fl := CBLuonnossaYks.Factor;
  if ( fk = 0 ) or ( fl = 0 ) then exit;
  Result := fk/fl;
end;

procedure TFormMuunnos.LaskeKartalla;
begin
  if ( EditMittak.Value = 0 ) then EditMittak.Value := 1;
//  EditKartalla.Value := EditLuonnossa.Value / EditMittak.Value / YksKerroin;
  EditKartalla.Value := CBKartallaYks.UnCode(
                           CBLuonnossaYks.Code(EditLuonnossa.Value)
                             / EditMittak.Value);
end;

procedure TFormMuunnos.LaskeLuonnossa;
begin
//  EditLuonnossa.Value := EditKartalla.Value * EditMittak.Value * YksKerroin;
  EditLuonnossa.Value := CBLuonnossaYks.UnCode(
                           CBKartallaYks.Code(EditKartalla.Value)
                             * EditMittak.Value);
end;

procedure TFormMuunnos.EditKartallaChange(Sender: TObject);
begin
  LaskeLuonnossa;
end;

procedure TFormMuunnos.EditLuonnossaChange(Sender: TObject);
begin
  LaskeKartalla;
end;

procedure TFormMuunnos.ButtonSelectAllClick(Sender: TObject);
var c : TControl;
begin
  c := ActiveControl;
  if  not ( c is TCustomEdit ) then exit;
  (c as TCustomEdit).SelectAll;
end;

procedure TFormMuunnos.CBKartallaYksChange(Sender: TObject);
begin
  LaskeLuonnossa;
end;

procedure TFormMuunnos.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFormMuunnos.GT1Click(Sender: TObject);
begin
  EditMittak.Value := (Sender as TComponent).Tag
end;

procedure TFormMuunnos.Tietoja1Click(Sender: TObject);
begin
  ShowMessage('Mittakaava-ohjelma' +#13#10+ 'vl 17.12.1997')
end;

procedure TFormMuunnos.Suomi1Click(Sender: TObject);
begin
//
end;

end.
